package jaredbgreat.dldungeons.pieces.chests;


/*This game mod is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/	


import java.util.Random;

import net.minecraft.block.Block;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import cpw.mods.fml.common.registry.GameRegistry;


public class LootItem {
	
	Object item;
	int min, max;
	
	
	public LootItem(Item item, int min, int max) {
		this.item = item;
		if(min > max) min = max;
		this.min = min;
		this.max = max;
	}
	
	
	public LootItem(Block item, int min, int max) {
		this.item = item;
		if(min > max) min = max;
		this.min = min;
		this.max = max;
	}
	
	
	public ItemStack getStack(Random random) {		
		if(max == min) {
			if(item instanceof Item)  return new ItemStack((Item)item, max);
			if(item instanceof Block) return new ItemStack((Block)item, max);
			System.out.println("[DLDUNGEONS] LootItem had invalid object type!");
			return null;
		}
		else {
			if(item instanceof Item) 
				return new ItemStack((Item)item, random.nextInt(max - min) + min +1);
			if(item instanceof Block) 
				return new ItemStack((Block)item, random.nextInt(max - min) + min +1);
			System.out.println("[DLDUNGEONS] LootItem had invalid object type!");
			return null;
		}
	}
	
	
	/*----------------------------------*/
	/*       Deafult Loots Below        */
	/*----------------------------------*/
	
	
	public static LootItem stoneSword   
			= new LootItem(GameRegistry.findItem("minecraft", "stone_sword"),   1, 1);
	public static LootItem ironSword    
			= new LootItem(GameRegistry.findItem("minecraft", "iron_sword"),    1, 1);
	public static LootItem diamondSword 
			= new LootItem(GameRegistry.findItem("minecraft", "diamond_sword"), 1, 1);
	public static LootItem bow          
			= new LootItem(GameRegistry.findItem("minecraft", "bow"),          1, 1);
	public static LootItem fewArrows    
			= new LootItem(GameRegistry.findItem("minecraft", "arrow"),        4, 12);
	public static LootItem someArrows   
			= new LootItem(GameRegistry.findItem("minecraft", "arrow"),        8, 16);
	public static LootItem manyArrows   
			= new LootItem(GameRegistry.findItem("minecraft", "arrow"),       16, 48);

	public static LootItem fewTorches   
			= new LootItem((Block)Block.getBlockFromName("torch"),   4, 12);
	public static LootItem someToreches 
			= new LootItem((Block)Block.getBlockFromName("torch"),  12, 16);
	public static LootItem manyTorches  
			= new LootItem((Block)Block.getBlockFromName("torch"),  16, 24);

	public static LootItem leatherHat   
			= new LootItem(GameRegistry.findItem("minecraft", "leather_helmet"), 1, 1);
	public static LootItem goldHat      
			= new LootItem(GameRegistry.findItem("minecraft", "golden_helmet"),    1, 1);
	public static LootItem ironHat      
			= new LootItem(GameRegistry.findItem("minecraft", "iron_helmet"),    1, 1);
	public static LootItem diamondHat   
			= new LootItem(GameRegistry.findItem("minecraft", "diamond_helmet"), 1, 1);
	public static LootItem leatherBoots 
			= new LootItem(GameRegistry.findItem("minecraft", "leather_boots"),  1, 1);
	public static LootItem goldBoots    
			= new LootItem(GameRegistry.findItem("minecraft", "golden_boots"),     1, 1);
	public static LootItem ironBoots    
			= new LootItem(GameRegistry.findItem("minecraft", "iron_boots"),     1, 1);
	public static LootItem diamondBoots 
			= new LootItem(GameRegistry.findItem("minecraft", "diamond_boots"), 1, 1);
	public static LootItem leatherPants 
			= new LootItem(GameRegistry.findItem("minecraft", "leather_leggings"),   1, 1);
	public static LootItem goldPants    
			= new LootItem(GameRegistry.findItem("minecraft", "golden_leggings"),      1, 1);
	public static LootItem ironPants    
			= new LootItem(GameRegistry.findItem("minecraft", "iron_leggings"),      1, 1);
	public static LootItem diamondPants 
			= new LootItem(GameRegistry.findItem("minecraft", "diamond_leggings"),   1, 1);
	public static LootItem leatherChest 
			= new LootItem(GameRegistry.findItem("minecraft", "leather_chestplate"),  1, 1);
	public static LootItem goldChest    
			= new LootItem(GameRegistry.findItem("minecraft", "golden_chestplate"),     1, 1);
	public static LootItem ironChest    
			= new LootItem(GameRegistry.findItem("minecraft", "iron_chestplate"),     1, 1);
	public static LootItem diamondChest 
			= new LootItem(GameRegistry.findItem("minecraft", "diamond_chestplate"),  1, 1);
	
	public static LootItem someBread    
			= new LootItem(GameRegistry.findItem("minecraft", "bread"),          2,  4);
	public static LootItem moreBread    
			= new LootItem(GameRegistry.findItem("minecraft", "bread"),          4,  8);
	public static LootItem someSteak    
			= new LootItem(GameRegistry.findItem("minecraft", "cooked_beef"),     2,  4);
	public static LootItem moreSteak    
			= new LootItem(GameRegistry.findItem("minecraft", "cooked_beef"),     4,  8);
	public static LootItem someChicken  
			= new LootItem(GameRegistry.findItem("minecraft", "cooked_chicken"),  2,  4);
	public static LootItem moreChicken  
			= new LootItem(GameRegistry.findItem("minecraft", "cooked_chicken"),  4,  8);
	public static LootItem someApples   
			= new LootItem(GameRegistry.findItem("minecraft", "apple"),       1,  3);
	public static LootItem moreApples   
			= new LootItem(GameRegistry.findItem("minecraft", "apple"),       2,  7);
	public static LootItem somePie      
			= new LootItem(GameRegistry.findItem("minecraft", "pumpkin_pie"),     1,  3);
	public static LootItem morePie      
			= new LootItem(GameRegistry.findItem("minecraft", "pumpkin_pie"),     2,  7);
	public static LootItem goldApple    
			= new LootItem(GameRegistry.findItem("minecraft", "golden_apple"),      1,  1);
	public static LootItem goldApples   
			= new LootItem(GameRegistry.findItem("minecraft", "golden_apple"),      1,  3);
	
	public static LootItem oneGold      
			= new LootItem(GameRegistry.findItem("minecraft", "gold_ingot"),      1, 1);
	public static LootItem someGold     
			= new LootItem(GameRegistry.findItem("minecraft", "gold_ingot"),      2, 5);
	public static LootItem moreGold     
			= new LootItem(GameRegistry.findItem("minecraft", "gold_ingot"),      3, 8);
	public static LootItem someIron     
			= new LootItem(GameRegistry.findItem("minecraft", "iron_ingot"),      1, 8);
	public static LootItem moreIron     
			= new LootItem(GameRegistry.findItem("minecraft", "iron_ingot"),      3, 12);	
	public static LootItem oneDiamond   
			= new LootItem(GameRegistry.findItem("minecraft", "iron_ingot"),        1, 1);
	public static LootItem diamonds     
			= new LootItem(GameRegistry.findItem("minecraft", "diamond"),        1, 4);
	public static LootItem manyDiamonds 
			= new LootItem(GameRegistry.findItem("minecraft", "diamond"),        3, 9);	
	public static LootItem oneEmerald   
			= new LootItem(GameRegistry.findItem("minecraft", "emerald"),        1, 1);
	public static LootItem emeralds     
			= new LootItem(GameRegistry.findItem("minecraft", "emerald"),        1, 4);
	public static LootItem manyEmerald  
			= new LootItem(GameRegistry.findItem("minecraft", "emerald"),        3, 7);
	
	public static LootItem saddle       
			= new LootItem(GameRegistry.findItem("minecraft", "saddle"),            1, 1);
	public static LootItem ironBarding  
			= new LootItem(GameRegistry.findItem("minecraft", "iron_horse_armor"),    1, 1);	
	public static LootItem goldBarding  
			= new LootItem(GameRegistry.findItem("minecraft", "golden_horse_armor"),    1, 1);
	public static LootItem diamondBard  
			= new LootItem(GameRegistry.findItem("minecraft", "diamond_horse_armor"), 1, 1);
	
	public static LootItem book         
			= new LootItem(GameRegistry.findItem("minecraft", "book"),           1, 1);
	public static LootItem someBooks    
			= new LootItem(GameRegistry.findItem("minecraft", "book"),           2, 5);
	public static LootItem moreBooks    
			= new LootItem(GameRegistry.findItem("minecraft", "book"),           3, 8);
	public static LootItem nameTag      
			= new LootItem(GameRegistry.findItem("minecraft", "name_tag"),        1, 1);	
	public static LootItem enderpearl   
			= new LootItem(GameRegistry.findItem("minecraft", "ender_pearl"),     1, 2);	
	public static LootItem enderpearls  
			= new LootItem(GameRegistry.findItem("minecraft", "ender_pearl"),     1, 9);
	public static LootItem eyeOfEnder   
			= new LootItem(GameRegistry.findItem("minecraft", "ender_eye"),     1, 2);
	public static LootItem blazeRod     
			= new LootItem(GameRegistry.findItem("minecraft", "blaze_rod"),       1, 2);
	public static LootItem netherstar   
			= new LootItem(GameRegistry.findItem("minecraft", "nether_star"),     1, 1);
	
	public static LootItem disc13       
			= new LootItem(GameRegistry.findItem("minecraft", "record_13"),      1, 1);
	public static LootItem discCat      
			= new LootItem(GameRegistry.findItem("minecraft", "record_cat"),     1, 1);
	public static LootItem discBlocks   
			= new LootItem(GameRegistry.findItem("minecraft", "record_blocks"),  1, 1);
	public static LootItem discChirp    
			= new LootItem(GameRegistry.findItem("minecraft", "stone_chirp"),   1, 1);	
	public static LootItem discFar      
			= new LootItem(GameRegistry.findItem("minecraft", "record_far"),     1, 1);	
	public static LootItem discMall     
			= new LootItem(GameRegistry.findItem("minecraft", "record_mall"),    1, 1);
	public static LootItem discMellohi  
			= new LootItem(GameRegistry.findItem("minecraft", "record_mellohi"), 1, 1);
	public static LootItem discStrad    
			= new LootItem(GameRegistry.findItem("minecraft", "record_strad"),   1, 1);
	public static LootItem discWard     
			= new LootItem(GameRegistry.findItem("minecraft", "record_ward"),    1, 1);
	public static LootItem disc11       
			= new LootItem(GameRegistry.findItem("minecraft", "record_11"),      1, 1);
	public static LootItem discWait     
			= new LootItem(GameRegistry.findItem("minecraft", "record_wait"),    1, 1);
}
